;
; picmac.h
;

; available as SKPC
;skipc	macro	; skip if carry
;	btfss	STATUS,C
;	endm

; available as SKPNC
;skipnc	macro	; skip if not carry
;	btfsc	STATUS,C
;	endm

; available as SKPZ
;skipz	macro	; skip if zero
;	btfss	STATUS,Z
;	endm

; available as SKPNZ
;skipnz	macro	; skip if not zero
;	btfsc	STATUS,Z
;	endm

skpos	macro	reg; skip if reg >= 0 (reg)
	btfsc	reg,7
	endm

skneg	macro	reg; skip if reg < 0 (reg)
	btfss	reg,7
	endm

; available as SETC
;setc	macro	; set carry
;	bsf	STATUS,C
;	endm

; available as CLRC
;clrc	macro	; clear carry
;	bcf	STATUS,C
;	endm

; available as BC
;bc	macro	dst;branch if carry
;	skipnc
;	goto	dst
;	endm

; available as BNC
;bnc	macro	dst;branch if no carry
;	skipc
;	goto	dst
;	endm

; available as BZ
;bz	macro	dst;branch if zero
;	skipnz
;	goto	dst
;	endm

; available as BNZ
;bnz	macro	dst;branch if not zero
;	skipz
;	goto	dst
;	endm

bpos	macro	reg,dst;branch if reg >= 0 (reg,dest_addr)
	btfss	reg,7
	goto	dst
	endm

bneg	macro	reg,dst;branch if reg < 0 (reg,dest_addr)
	btfsc	reg,7
	goto	dst
	endm

brset	macro	reg,bit,dst;branch if bit set (reg,bit,dest_addr)
	btfsc	reg,bit
	goto	dst
	endm

brclr	macro	reg,bit,dst;branch if bit clear (reg,bit,dest_addr)
	btfss	reg,bit
	goto	dst
	endm

;
; save W/STATUS (interrupt entry)
;
save_w_stat macro
	movwf	temp_w
	swapf	STATUS,W
	movwf	temp_s
	endm

restore_w_stat macro
	swapf	temp_s,W
	movwf	STATUS
	swapf	temp_w,F
	swapf	temp_w,W
	endm
